SystemOrganization addCategory: #TreeMorphTest!

TestCase subclass: #AbstractTreeBrowserTest
	instanceVariableNames: 'browser classWithComments classWithoutComments methodWithComments methodWithoutComments packageWithDocumentation packageWithoutDocumentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!AbstractTreeBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/2/2012 14:32'!
classToTest
	self subclassResponsibility.! !

!AbstractTreeBrowserTest methodsFor: 'accessing' stamp: 'GonzaloMunoz 1/8/2012 00:53'!
packages
	^ PackageOrganizer default packages collect: [ :aPackageInfo | PackageInfoListItemWrapper with: aPackageInfo ]! !

!AbstractTreeBrowserTest methodsFor: 'running' stamp: 'GonzaloMunoz 1/8/2012 22:32'!
setUp
	| packages |
	packages := PackageOrganizer default packages
		collect: [ :aPackageInfo | PackageInfoListItemWrapper with: aPackageInfo ].
	browser := self classToTest new.
	packageWithDocumentation := packages
		detect: [ :packageListItem | packageListItem contents anySatisfy: [ :classListItem | classListItem item hasComment ] ].
	packageWithoutDocumentation := packages
		detect: [ :packageListItem | packageListItem contents allSatisfy: [ :classListItem | classListItem item hasComment not ] ].
	classWithComments := packageWithDocumentation contents detect: [ :classListItem | classListItem item hasComment ].
	classWithoutComments := packageWithoutDocumentation contents
		detect: [ :classListItem | classListItem item hasComment not ].
	packages
		anySatisfy: [ :packageListItem | 
			packageListItem contents
				anySatisfy: [ :classListItem | 
					classListItem contents
						anySatisfy: [ :methodListItem | 
							methodListItem item comment notNil
								ifTrue: [ methodWithComments := methodListItem ].
							methodListItem item comment notNil ] ] ].
	packages
		anySatisfy: [ :packageListItem | 
			packageListItem contents
				anySatisfy: [ :classListItem | 
					classListItem contents
						anySatisfy: [ :methodListItem | 
							methodListItem item comment isNil
								ifTrue: [ methodWithoutComments := methodListItem ].
							methodListItem item comment isNil ] ] ]! !

!AbstractTreeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:32'!
testOnItemClickNil
	self shouldnt: [ browser onItemClick: nil ] raise: MessageNotUnderstood.! !

AbstractTreeBrowserTest subclass: #CodeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!CodeBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/2/2012 14:37'!
classToTest
	^ CodeBrowser.! !

!CodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 21:37'!
testClassCodeView
	browser
		show;
		visitClassDescription: classWithComments item.
	self assert: browser viewTextAsString equals: classWithComments item definition! !

!CodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:00'!
testMethodCodeView
	browser
		show;
		visitCompiledMethod: methodWithComments item.
	self assert: browser viewTextAsString equals: methodWithComments item getSource.! !

!CodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 19:47'!
testOnItemClickNil
	super testOnItemClickNil! !

!CodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:16'!
testPackageCodeView
	browser
		show;
		visitPackageInfo: packageWithDocumentation item.
	self assert: browser viewTextAsString equals: ''.! !

AbstractTreeBrowserTest subclass: #DocumentationBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!DocumentationBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/3/2012 23:26'!
classToTest
	^ TreeBrowser.! !

!DocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:19'!
testClassDocumentationView
	browser
		show;
		visitClassDescription: classWithComments item.
	self assert: browser viewTextAsString equals: classWithComments item comment.
	browser visitClassDescription: classWithoutComments item.
	self assert: browser viewTextAsString equals: 'PAS DE COMMENTAIRES'! !

!DocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:24'!
testMethodDocumentationView
	browser
		show;
		visitCompiledMethod: methodWithComments item.
	self assert: browser viewTextAsString equals: methodWithComments item comment.
	browser visitCompiledMethod: methodWithoutComments item.
	self assert: browser viewTextAsString equals: 'PAS DE COMMENTAIRES'! !

!DocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 19:47'!
testOnItemClickNil
	super testOnItemClickNil! !

!DocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:22'!
testPackageDocumentationView
	browser
		show;
		visitPackageInfo: packageWithDocumentation item.
	self assert: browser viewTextAsString equals: (browser documentationForPackage: packageWithDocumentation item).
	browser visitPackageInfo: packageWithoutDocumentation item.
	self assert: browser viewTextAsString equals: ''! !
